=== modified file 'lib/lp/blueprints/browser/configure.zcml'
--- lib/lp/blueprints/browser/configure.zcml	2011-06-19 13:32:15 +0000
+++ lib/lp/blueprints/browser/configure.zcml	2011-07-01 11:27:27 +0000
@@ -135,6 +135,7 @@
         permission="zope.Public"/>
     <browser:pages
         for="lp.blueprints.interfaces.sprint.IHasSprints"
+        class="canonical.launchpad.webapp.LaunchpadView"
         facet="overview"
         permission="zope.Public">
         <browser:page

=== modified file 'lib/lp/bugs/browser/configure.zcml'
--- lib/lp/bugs/browser/configure.zcml	2011-06-17 10:31:55 +0000
+++ lib/lp/bugs/browser/configure.zcml	2011-07-01 11:27:27 +0000
@@ -883,6 +883,7 @@
             name="+index"/>
         <browser:pages
             for="lp.bugs.interfaces.bugtracker.IRemoteBug"
+            class="canonical.launchpad.webapp.LaunchpadView"
             permission="zope.Public">
             <browser:page
                 name="+index"

=== modified file 'lib/lp/bugs/browser/cve.py'
--- lib/lp/bugs/browser/cve.py	2011-02-24 15:30:54 +0000
+++ lib/lp/bugs/browser/cve.py	2011-07-01 11:27:27 +0000
@@ -20,6 +20,7 @@
     canonical_url,
     ContextMenu,
     GetitemNavigation,
+    LaunchpadView,
     Link,
     )
 from canonical.launchpad.webapp.batching import BatchNavigator
@@ -122,11 +123,10 @@
     heading = 'Remove links to bug reports'
 
 
-class CveSetView:
+class CveSetView(LaunchpadView):
 
     def __init__(self, context, request):
-        self.context = context
-        self.request = request
+        super(CveSetView, self).__init__(context, request)
         self.notices = []
         self.results = None
         self.text = self.request.form.get('text', None)

=== modified file 'lib/lp/code/browser/bazaar.py'
--- lib/lp/code/browser/bazaar.py	2010-08-31 11:24:54 +0000
+++ lib/lp/code/browser/bazaar.py	2011-07-01 11:27:27 +0000
@@ -87,7 +87,7 @@
     @cachedproperty
     def short_product_tag_cloud(self):
         """Show a preview of the product tag cloud."""
-        return BazaarProductView().products(
+        return BazaarProductView(None, None).products(
             num_products=config.launchpad.code_homepage_product_cloud_size)
 
 
@@ -150,7 +150,7 @@
         self.request.response.redirect(redirect_url, status=301)
 
 
-class BazaarProductView:
+class BazaarProductView(LaunchpadView):
     """Browser class for products gettable with Bazaar."""
 
     def _make_distribution_map(self, values, percentile_map):

=== modified file 'lib/lp/registry/browser/distributionsourcepackage.py'
--- lib/lp/registry/browser/distributionsourcepackage.py	2011-06-23 13:03:40 +0000
+++ lib/lp/registry/browser/distributionsourcepackage.py	2011-07-01 11:27:27 +0000
@@ -262,7 +262,7 @@
         return Link('+changelog', text, icon="info")
 
 
-class DistributionSourcePackageBaseView:
+class DistributionSourcePackageBaseView(LaunchpadView):
     """Common features to all `DistributionSourcePackage` views."""
 
     def releases(self):
@@ -618,7 +618,7 @@
     cancel_url = next_url
 
 
-class DistributionSourcePackageHelpView:
+class DistributionSourcePackageHelpView(LaunchpadView):
     """A View to show Answers help."""
 
     page_title = 'Help and support options'

=== modified file 'lib/lp/registry/browser/peoplemerge.py'
--- lib/lp/registry/browser/peoplemerge.py	2011-05-27 21:12:25 +0000
+++ lib/lp/registry/browser/peoplemerge.py	2011-07-01 11:27:27 +0000
@@ -342,19 +342,18 @@
             return ''
 
 
-class RequestPeopleMergeMultipleEmailsView:
+class RequestPeopleMergeMultipleEmailsView(LaunchpadView):
     """Merge request view when dupe account has multiple email addresses."""
 
     label = 'Merge Launchpad accounts'
     page_title = label
 
     def __init__(self, context, request):
-        self.context = context
-        self.request = request
+        super(RequestPeopleMergeMultipleEmailsView, self).__init__(
+            context, request)
         self.form_processed = False
         self.dupe = None
         self.notified_addresses = []
-        self.user = getUtility(ILaunchBag).user
 
     def processForm(self):
         dupe = self.request.form.get('dupe')

=== modified file 'lib/lp/registry/browser/sourcepackage.py'
--- lib/lp/registry/browser/sourcepackage.py	2011-05-27 21:12:25 +0000
+++ lib/lp/registry/browser/sourcepackage.py	2011-07-01 11:27:27 +0000
@@ -424,7 +424,7 @@
                 'The packaging link has already been deleted.')
 
 
-class SourcePackageView:
+class SourcePackageView(LaunchpadView):
     """A view for (distro series) source packages."""
 
     def initialize(self):

=== modified file 'lib/lp/registry/browser/teammembership.py'
--- lib/lp/registry/browser/teammembership.py	2011-05-27 21:12:25 +0000
+++ lib/lp/registry/browser/teammembership.py	2011-07-01 11:27:27 +0000
@@ -40,12 +40,10 @@
         return "%s's membership" % self.context.person.displayname
 
 
-class TeamMembershipEditView:
+class TeamMembershipEditView(LaunchpadView):
 
     def __init__(self, context, request):
-        self.context = context
-        self.request = request
-        self.user = getUtility(ILaunchBag).user
+        super(TeamMembershipEditView, self).__init__(context, request)
         self.errormessage = ""
         self.prefix = 'membership'
         self.max_year = 2050

=== modified file 'lib/lp/registry/browser/tests/test_subscription_links.py'
--- lib/lp/registry/browser/tests/test_subscription_links.py	2011-06-22 14:09:43 +0000
+++ lib/lp/registry/browser/tests/test_subscription_links.py	2011-07-01 11:27:27 +0000
@@ -69,7 +69,7 @@
             None, self.new_edit_link,
             "Expected edit_bug_mail link missing")
         # Ensure the LP.cache has been populated.
-        self.assertTrue("LP.cache['administratedTeams']" in self.contents)
+        self.assertIn('LP.cache = {"administratedTeams": [', self.contents)
         # Ensure the call to setup the subscription is in the HTML.
         # Only check for the presence of setup's configuration step; more
         # detailed checking is needlessly brittle.

=== modified file 'lib/lp/soyuz/browser/distroarchseriesbinarypackage.py'
--- lib/lp/soyuz/browser/distroarchseriesbinarypackage.py	2010-08-20 20:31:18 +0000
+++ lib/lp/soyuz/browser/distroarchseriesbinarypackage.py	2011-07-01 11:27:27 +0000
@@ -11,6 +11,7 @@
 from canonical.launchpad.webapp import (
     ApplicationMenu,
     GetitemNavigation,
+    LaunchpadView,
     )
 from canonical.launchpad.webapp.breadcrumb import Breadcrumb
 from canonical.lazr.utils import smartquote
@@ -31,11 +32,7 @@
     usedfor = IDistroArchSeriesBinaryPackage
 
 
-class DistroArchSeriesBinaryPackageView:
-
-    def __init__(self, context, request):
-        self.context = context
-        self.request = request
+class DistroArchSeriesBinaryPackageView(LaunchpadView):
 
     @property
     def page_title(self):

=== modified file 'lib/lp/soyuz/browser/distroarchseriesbinarypackagerelease.py'
--- lib/lp/soyuz/browser/distroarchseriesbinarypackagerelease.py	2010-08-20 20:31:18 +0000
+++ lib/lp/soyuz/browser/distroarchseriesbinarypackagerelease.py	2011-07-01 11:27:27 +0000
@@ -11,6 +11,7 @@
 
 from canonical.launchpad.webapp import (
     ApplicationMenu,
+    LaunchpadView,
     Navigation,
     )
 from canonical.launchpad.webapp.breadcrumb import Breadcrumb
@@ -38,7 +39,7 @@
     usedfor = IDistroArchSeriesBinaryPackageRelease
 
 
-class DistroArchSeriesBinaryPackageReleaseView:
+class DistroArchSeriesBinaryPackageReleaseView(LaunchpadView):
 
     def __init__(self, context, request):
         self.context = context

=== modified file 'lib/lp/soyuz/browser/distroseriesbinarypackage.py'
--- lib/lp/soyuz/browser/distroseriesbinarypackage.py	2010-08-20 20:31:18 +0000
+++ lib/lp/soyuz/browser/distroseriesbinarypackage.py	2011-07-01 11:27:27 +0000
@@ -12,6 +12,7 @@
 
 from canonical.launchpad.webapp import (
     ApplicationMenu,
+    LaunchpadView,
     Navigation,
     StandardLaunchpadFacets,
     )
@@ -49,7 +50,7 @@
         return self.context.binarypackagename.name
 
 
-class DistroSeriesBinaryPackageView:
+class DistroSeriesBinaryPackageView(LaunchpadView):
 
     def __init__(self, context, request):
         self.context = context

=== modified file 'lib/lp/soyuz/browser/distroseriessourcepackagerelease.py'
--- lib/lp/soyuz/browser/distroseriessourcepackagerelease.py	2010-08-20 20:31:18 +0000
+++ lib/lp/soyuz/browser/distroseriessourcepackagerelease.py	2011-07-01 11:27:27 +0000
@@ -10,6 +10,7 @@
 
 from canonical.launchpad.webapp import (
     ApplicationMenu,
+    LaunchpadView,
     Navigation,
     stepthrough,
     )
@@ -49,7 +50,7 @@
         return None
 
 
-class DistroSeriesSourcePackageReleaseView:
+class DistroSeriesSourcePackageReleaseView(LaunchpadView):
 
     def __init__(self, context, request):
         self.context = context

=== modified file 'lib/lp/soyuz/browser/sourcepackage.py'
--- lib/lp/soyuz/browser/sourcepackage.py	2011-05-12 12:09:17 +0000
+++ lib/lp/soyuz/browser/sourcepackage.py	2011-07-01 11:27:27 +0000
@@ -12,7 +12,10 @@
 
 from zope.component import getUtility
 
-from canonical.launchpad.webapp import Navigation
+from canonical.launchpad.webapp import (
+    LaunchpadView,
+    Navigation,
+    )
 from canonical.lazr.utils import smartquote
 from lp.registry.interfaces.distribution import IDistributionSet
 from lp.registry.interfaces.distroseries import IDistroSeriesSet
@@ -21,7 +24,7 @@
     )
 
 
-class SourcePackageChangelogView:
+class SourcePackageChangelogView(LaunchpadView):
     """View class for source package change logs."""
 
     page_title = "Change log"
@@ -32,7 +35,7 @@
         return smartquote("Change logs for " + self.context.title)
 
 
-class SourcePackageCopyrightView:
+class SourcePackageCopyrightView(LaunchpadView):
     """A view to display a source package's copyright information."""
 
     page_title = "Copyright"

=== modified file 'lib/lp/translations/browser/sourcepackage.py'
--- lib/lp/translations/browser/sourcepackage.py	2011-04-21 19:56:36 +0000
+++ lib/lp/translations/browser/sourcepackage.py	2011-07-01 11:27:27 +0000
@@ -43,7 +43,7 @@
 from lp.translations.model.translationpackagingjob import TranslationMergeJob
 
 
-class SourcePackageTranslationsView(TranslationsMixin,
+class SourcePackageTranslationsView(LaunchpadView, TranslationsMixin,
                                     TranslationSharingDetailsMixin):
 
     @property

=== modified file 'lib/lp/translations/browser/translations.py'
--- lib/lp/translations/browser/translations.py	2011-05-27 19:53:20 +0000
+++ lib/lp/translations/browser/translations.py	2011-07-01 11:27:27 +0000
@@ -56,13 +56,9 @@
             rootsite='answers')
 
 
-class RosettaApplicationView(TranslationsMixin):
+class RosettaApplicationView(LaunchpadView, TranslationsMixin):
     """View for various top-level Translations pages."""
 
-    def __init__(self, context, request):
-        self.context = context
-        self.request = request
-
     @property
     def ubuntu_translationseries(self):
         ubuntu = getUtility(ILaunchpadCelebrities).ubuntu

